IncludeScript(projectDir + "/_charlib/weapon_list.nut");
IncludeScript(projectDir + "/_charlib/custom_sounds.nut");

::ConvertToCustomCharacter <- function(player, includeScript)
{
    ClearCustomCharacter(player);

    player.ValidateScriptScope();
    local playerScript = player.GetScriptScope();

    IncludeScript(projectDir + "/_charlib/custom_character.nut", playerScript);
    try
    {
        IncludeScript(includeScript, playerScript);
    }
    catch (e)
    {
        playerScript.ConvertToCharacterInternal();
        throw e;
    }
    playerScript.ConvertToCharacterInternal();
}

::ClearCustomCharacter <- function(player)
{
    if (GetCustomCharacter(player))
    {
        player.GetScriptScope().ClearCustomCharacterInternal();
        return true;
    }
    return false;
}

::GetCustomCharacter <- function(player)
{
    return safeget(safescriptget(player, "characterSettings", null), "name", null);
}

OnGameEvent("post_inventory_application", -20, function(player, params)
{
    local array = charFixArray[player.entindex()];
    local index = array.find(GetCustomCharacter(player));
    if (index != null)
    {
        array.remove(index);
        return 117115;
    }
});

::charFixArray <- player_collection([]);

::CTFPlayer.RespawnFix <- function()
{
    charFixArray[this.entindex()].push(GetCustomCharacter(this));
}
::CTFBot.RespawnFix <- ::CTFPlayer.RespawnFix

::CTFPlayer.HasRespawnFix <- function()
{
    return charFixArray[this.entindex()].find(GetCustomCharacter(this)) != null;
}
::CTFBot.HasRespawnFix <- ::CTFPlayer.HasRespawnFix