characterSettings.name <- "vip";
characterSettings.playerClass <- TF_CLASS_DEMOMAN;
characterSettings.model <- API_GetString("civilian_model");
characterSettings.viewmodelHands <- API_GetString("civilian_arms_model");
characterSettings.scale <- API_GetFloat("civilian_scale");
characterSettings.deleteItems <- true;
characterSettings.mute <- true;
characterSettings.cleanOnDeath <- true;
characterSettings.cleanOnClassChange <- true;

IncludeScript("vip/vip_civilian/vip_buff_lockon.nut");
IncludeScript("vip/vip_civilian/vip_buffs.nut");
IncludeScript("vip/vip_civilian/vip_headshot.nut");
IncludeScript("vip/vip_civilian/vip_nag.nut");
IncludeScript("vip/vip_civilian/vip_mediccall.nut");
IncludeScript("vip/vip_civilian/vip_fixes.nut");

EntFireByHandle(SpawnEntityFromTable("info_teleport_destination",
{
    origin = self.GetCenter(),
    vscripts = "vip/entities/vip_dispenser.nut",
    thinkfunction = "DispenserThink",
    TeamNum = GetFakeTeam(self)
}), "SetParent", "!activator", 0, self, self);

EntFireByHandle(SpawnEntityFromTable("info_teleport_destination",
{
    origin = self.GetCenter(),
    vscripts = "vip/entities/vip_team_outline.nut",
    TeamNum = GetFakeTeam(self)
}), "SetParent", "!activator", 0, self, self);

AddTimer(1, function()
{
    local hp = self.GetHealth();
    local newHP = clampCeiling(self.GetMaxHealth(), hp + 3);
    if (hp > 0 && newHP > hp)
        self.SetHealth(newHP);
});

OnSelfGameEvent("post_inventory_application", 0, function()
{
    //CreateViewModel(characterSettings.viewmodelHands);
    CreateViewModel(API_GetString("cane_pickup_model"));
    //todo

    self.AddHudHideFlags(HIDEHUD_PIPES_AND_CHARGE);
    SetPropInt(self, "m_Shared.m_bShieldEquipped", 0);
    vipBoostTokens <- vipBoostTokensStart;
    self.KeyValueFromString("targetname", "vip");

    self.AddCustomAttribute("voice pitch scale", 0, -1);
    self.AddCustomAttribute("dmg taken from fire reduced", 0.8, -1);
    self.AddCustomAttribute("dmg taken from crit reduced", 0.8, -1);
    self.AddCustomAttribute("damage bonus HIDDEN", 0.54, -1);
    self.AddCustomAttribute("fire rate bonus HIDDEN", 0.625, -1);

    self.SetHealth(175);
    self.SetMaxHealth(175);
    self.RemoveCond(TF_COND_DISGUISED);
    self.RemoveCond(TF_COND_DISGUISING);

    self.Weapon_Switch(EquipWeapon(GetWeaponTypeByName("cane_julius")));

    foreach (otherPlayer in GetAlivePlayers())
    {
        if (otherPlayer.GetPlayerClass() != TF_CLASS_MEDIC)
            return;
        local medigun = otherPlayer.GetActiveWeapon();
        if (GetPropEntity(medigun, "m_hHealingTarget") == self)
            SetPropEntity(medigun, "m_hHealingTarget", null);
    }
});

OnSelfGameEvent("clear_custom_character", 0, function(player, params)
{
    KillLockVFX();
    DoEntFire(GetFakeTeamName(player) + "_vip_death*", "Trigger", "", -1, player, player);
    FireCustomEvent("vip_death", params);
    self.RemoveHudHideFlags(HIDEHUD_PIPES_AND_CHARGE);
});

OnSelfEvent("player_death_next", function(params)
{
    SetPropBool(GetPropEntity(self, "m_hRagdoll"), "m_bGib", true);
});

OnSelfEvent("player_death_post", function(params)
{
    SetPropBool(GetPropEntity(self, "m_hRagdoll"), "m_bGib", true);
});