characterSettings.name <- "vip";
characterSettings.playerClass <- TF_CLASS_HEAVY;
characterSettings.model <- API_GetString("vip_model");
characterSettings.viewmodelHands <- API_GetString("vip_arms_model");
characterSettings.scale <- API_GetFloat("vip_scale");
characterSettings.deleteItems <- true;
characterSettings.mute <- true;
characterSettings.cleanOnDeath <- true;
characterSettings.cleanOnClassChange <- true;

IncludeScript("vip/vip_mobster/vip_moneybag_recharge.nut");
IncludeScript("vip/vip_mobster/vip_headshot.nut");
IncludeScript("vip/vip_mobster/vip_nag.nut");
IncludeScript("vip/vip_mobster/vip_mediccall.nut");
IncludeScript("vip/vip_mobster/vip_fixes.nut");
IncludeScript("vip/vip_mobster/vip_experiments.nut");
IncludeScript("vip/vip_mobster/vip_failsafe.nut");

OnSelfEvent("init_custom_character", 0, function()
{
    CreateViewModel(characterSettings.viewmodelHands);
    self.KeyValueFromString("targetname", "vip");

    self.AddCustomAttribute("patient overheal penalty", 0.2, -1);
    self.AddCustomAttribute("airblast vulnerability multiplier", 0.4, -1);

    self.SetHealth(500);
    self.SetMaxHealth(500);
    self.RemoveCustomAttribute("max health additive penalty");
    self.AddCustomAttribute("max health additive penalty", 200, -1);
    self.RemoveCond(TF_COND_DISGUISED);
    self.RemoveCond(TF_COND_DISGUISING);

    local superSmg = EquipWeapon(GetWeaponTypeByName("super_smg"));
    EquipWeapon(GetWeaponTypeByName("money_bag"));
    EquipWeapon(GetWeaponTypeByName("cane"));
    OnNextTick(function() {
        self.Weapon_Switch(superSmg);
    })

    foreach (otherPlayer in GetAlivePlayers())
    {
        if (otherPlayer.GetPlayerClass() != TF_CLASS_MEDIC)
            return;
        local medigun = otherPlayer.GetActiveWeapon();
        if (GetPropEntity(medigun, "m_hHealingTarget") == self)
            SetPropEntity(medigun, "m_hHealingTarget", null);
    }
});

OnSelfEvent("player_death", 0, function(params)
{
    DoEntFire(GetFakeTeamName(self) + "_vip_death*", "Trigger", "", -1, self, self);
    FireCustomEvent("vip_death", params);
    vipPlayers[GetFakeTeam(self)] = null;
});